<script>
import loader from '@monaco-editor/loader';
import setConfigs from '@gitlab/ui/dist/config';
import {
  GlButton,
  GlSkeletonLoader,
  GlDropdown,
  GlDropdownItem,
} from '@gitlab/ui';
import HeaderMenu from './components/header.vue';
import CodeResult from './components/code_result.vue';

setConfigs();

export default {
  name: 'IndexPage',
  auth: false,
  components: {
    HeaderMenu,
    GlSkeletonLoader,
    GlButton,
    GlDropdown,
    GlDropdownItem,
    CodeResult,
  },
  data: () => ({
    currentQuestion: '',
    currentSource: '',
    loading: false,
    language: 'javascript',
    result: null,
    sampleTestResults: null,
  }),
  fetchOnServer: false,
  computed: {
    askText() {
      if (this.currentSource === 'doc') {
        return 'Ask about the product';
      } else if (this.currentSource === 'handbook') {
        return 'Ask about the handbook';
      } else if (this.currentSource === 'blog') {
        return 'Ask about the Blog';
      }
      return 'Ask anything';
    },
    startSource: function () {
      return '// Show an alert with Hello World';
    },
  },
  created: async function () {
    this.loading = true;
    this.testResults = await this.$axios.$get('/api/results');
    this.loading = false;
  },
  async mounted() {
    const _this = this;
    await loader.init().then((monaco) => {
      _this.editorInstance = monaco.editor.create(this.$refs.editor, {
        value: _this.startSource,
        language: this.language,
        automaticLayout: false,
        minimap: false,
      });
    });
  },
  methods: {
    codify: (code) => {
      return code;
    },
    getSuggestions: async function () {
      const sourceValue = this.editorInstance.getValue();
      this.result = null;
      if (sourceValue) {
        this.loading = true;
        this.result = await this.$axios.$post('/api/suggestions', {
          language: this.language,
          source: sourceValue,
        });
        this.loading = false;
        // eslint-disable-next-line no-console
        console.log('API Result : ', this.result);
      }
    },
    selectSource: function (sourceType) {
      this.currentSource = sourceType;
    },
    selectLanguage: function (selectedLanguage) {
      this.language = selectedLanguage;
      let sourceValue = '';
      if (selectedLanguage === 'javascript') {
        sourceValue = '// Show an alert with Hello World';
      } else if (selectedLanguage === 'python') {
        sourceValue = '# Start the server on port 3000';
      } else if (selectedLanguage === 'golang') {
        sourceValue = '// implement a small cli program that shows hello world';
      } else if (selectedLanguage === 'c') {
        sourceValue = 'int main(int 	argc, char *argv[])';
      }
      this.editorInstance.setValue(sourceValue);
    },
  },
};
</script>

<template>
  <div class="">
    <div class="container gl-mt-7 gl-mb-4 gl-display-flex">
      <div>
        <h2 class="gl-mt-0">Code Suggestions Evaluation</h2>
      </div>
    </div>
    <div
      class="gl-bg-gray-10 gl-border-gray-50 gl-border-solid gl-border-0 gl-border-t-1 gl-border-b-1 gl-pt-4 gl-pb-4"
    >
      <div class="container distributed md typography">
        <header-menu></header-menu>
      </div>
    </div>

    <div class="container distributed md typography gl-mt-4">
      <div>
        <p>
          You can also simulate the position of the current CURSOR by adding
          "[[CURSOR]]" at that position, which splits for some models the
          context in pre and sufix.
        </p>
      </div>
      <div class="gl-mb-6">
        <gl-dropdown :text="language">
          <gl-dropdown-item @click="selectLanguage('javascript')"
            >javascript</gl-dropdown-item
          >
          <gl-dropdown-item @click="selectLanguage('python')"
            >python</gl-dropdown-item
          >
          <gl-dropdown-item @click="selectLanguage('golang')"
            >golang</gl-dropdown-item
          >
          <gl-dropdown-item @click="selectLanguage('c')">c</gl-dropdown-item>
        </gl-dropdown>
      </div>
      <div ref="editor" style="min-height: 450px; min-width: 600px"></div>
      <div class="gl-mb-6 gl-mt-2">
        <gl-button variant="confirm" :loading="loading" @click="getSuggestions"
          >Get Suggestions from all models!</gl-button
        >
      </div>
      <gl-skeleton-loader v-if="loading"></gl-skeleton-loader>
      <div
        v-if="!loading && result"
        class="container distributed md typography gl-mb-6"
      >
        <div class="gl-display-flex">
          <div class="gl-flex-grow-1 gl-mr-4">
            <code-result
              :name="'Original Prompt for ' + result.language"
              :language="result.language"
              :source="
                result.prompt.join ? result.prompt.join(' ') : result.prompt
              "
            ></code-result>
          </div>
          <div class="gl-flex-grow-1">
            <code-result
              name="GitLab current Code suggestions"
              :language="result.language"
              :test="result.gitlab_model"
            ></code-result>
          </div>
        </div>
        <div class="gl-display-flex">
          <div class="gl-flex-grow-1 gl-mr-4">
            <code-result
              name="Anthropic"
              :language="result.language"
              :test="result.anthropic"
            ></code-result>
          </div>
          <div class="gl-flex-grow-1">
            <code-result
              name="Anthropic Fast"
              :language="result.language"
              :test="result.anthropic_fast"
            ></code-result>
          </div>
        </div>
        <div class="gl-display-flex">
          <div class="gl-flex-grow-1 gl-mr-4">
            <code-result
              name="Vertex Combined (code-bison + gecko)"
              :language="result.language"
              :test="result.vertex_combined"
            ></code-result>
          </div>
          <div class="gl-flex-grow-1">
            <code-result
              name="Vertex Gecko"
              :language="result.language"
              :test="result.vertex_gecko"
            ></code-result>
          </div>
        </div>
        <div class="gl-display-flex">
          <div class="gl-flex-grow-1 gl-mr-4">
            <code-result
              name="Vertex Code Bison"
              :language="result.language"
              :test="result.vertex_text_bison"
            ></code-result>
          </div>
          <div class="gl-flex-grow-1">
            <code-result
              name="Vertex Text Bison"
              :language="result.language"
              :test="result.vertex_text_bison"
            ></code-result>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<style scoped></style>
